︠bdbb3646-99e4-48ca-9ba8-8f2fed0f86fci︠
%md
# Math 152: Intro to Mathematical Software
### 2017-01-27
### Kiran Kedlaya; University of California, San Diego
### adapted from lectures by William Stein, University of Washington

## ** Lecture 8: Symbolic Calculus (part 1) **

︡70e03e40-9a05-428f-83b3-b56d801d9744︡{"done":true,"md":"# Math 152: Intro to Mathematical Software\n### 2017-01-27\n### Kiran Kedlaya; University of California, San Diego\n### adapted from lectures by William Stein, University of Washington\n\n## ** Lecture 8: Symbolic Calculus (part 1) **"}
︠d1c71866-fbba-486f-bb07-3a6a3714abd8i︠
%md

**Announcements:**

Usual schedule next week! (including sections, office hours, homework, peer evaluation)

︡92feb9c9-327a-4853-ac0f-adaf68758823︡{"done":true,"md":"\n**Announcements:**\n\nUsual schedule next week! (including sections, office hours, homework, peer evaluation)"}
︠f5cd73aa-1fe8-499a-b7e5-ff60e8236703︠
%md
## Some Resources for Symbolic Calculus in Sage

- Basic Sage Calculus Tutorial: http://www.sagemath.org/calctut/
- Sage for Undergraduates: http://www.gregorybard.com/Sage.html
- Sage reference manual: http://doc.sagemath.org/html/en/reference/calculus/index.html
- Sage Calculus "thematic tutorial": http://doc.sagemath.org/html/en/prep/Calculus.html

︡0f89a429-144c-48e6-8adc-bcaa890f8ded︡{"done":true,"md":"## Some Resources for Symbolic Calculus in Sage\n\n- Basic Sage Calculus Tutorial: http://www.sagemath.org/calctut/\n- Sage for Undergraduates: http://www.gregorybard.com/Sage.html\n- Sage reference manual: http://doc.sagemath.org/html/en/reference/calculus/index.html\n- Sage Calculus \"thematic tutorial\": http://doc.sagemath.org/html/en/prep/Calculus.html"}
︠765bec67-3405-425b-bedd-8c16be6835c3︠
%md
## Short crash course

- defining symbolic variables
- defining symbolic functions
- plot
- differente
- integrate
- finding zeros
︡be0733fe-3423-4f86-8228-6e64bf075c31︡︡{"done":true,"md":"## Short crash course\n\n- defining symbolic variables\n- defining symbolic functions\n- plot\n- differente\n- integrate\n- finding zeros"}
︠8acc432e-0c4d-4b93-987a-a6e09419463es︠
reset()
︡421a71b7-3b86-4b55-8ef6-54256d54be20︡{"done":true}︡
︠d96086b7-13db-4b10-a460-2d7bf0aaa2d7s︠
x*x
︡06d0f79c-bdd9-4e96-8953-609dd5e2e98d︡{"stdout":"x^2"}︡{"stdout":"\n"}︡{"done":true}︡
︠8837ffee-a357-4f6e-93ad-2a02fda501bfs︠
y + theta
︡f90dacab-d55f-40e2-874b-e8f79501bb19︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n"}︡{"stderr":"  File \"\", line 1, in <module>\nNameError: name 'y' is not defined\n"}︡{"done":true}︡
︠e6652737-7736-4840-9f3a-b59384777060s︠
# x is predefined; can define other variables...

%var y, theta, aleph, xi
︡5c0662ce-7981-49a7-bec3-7e16b02f4495︡{"done":true}︡
︠4027c56a-9041-420c-b2f8-ac50871ba166︠

︡fdbe18b5-7952-4e05-a500-4f8dc9bd2bf0︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}︡
︠b889592c-d9ed-4690-9327-79e1d21c3096s︠
show(x+y+theta +aleph+xi)
type(y)
︡f4d7c348-de21-4558-b229-04902e1d245a︡{"html":"<div align='center'>$\\displaystyle \\mathit{aleph} + \\theta + x + \\xi + y$</div>"}︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}︡
︠2af3df84-728f-4c66-be6f-9ccbd7efe36bs︠
var('y, theta')
︡bc595144-cd01-4d14-92dc-0235a69a5267︡{"stdout":"(y, theta)\n"}︡{"done":true}︡
︠212e19c9-8402-420c-aa96-1a934684007cs︠
f(z, william) = z*(z+1)*william
f()
︡8a1d6414-1438-4777-b817-74c60705c7ce︡{"stdout":"william*(z + 1)*z\n"}︡{"done":true}︡
︠c7514abd-f947-42de-8e2e-d9e419a0101cs︠
z + william
︡44bfe529-ffd7-48f9-85b8-6d3aa55758a8︡{"stdout":"william + z\n"}︡{"done":true}︡
︠e1f8705b-dd46-4e0c-8708-1e44f230a2cbs︠
type(william)
︡5bc8452e-832e-4db6-b451-c2d2cf5e9c63︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}
︠122b17f9-bfe5-45e9-843e-8fbf8a984283s︠
type(f)
︡157bae60-6d02-4764-b95d-d046207a32b3︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}︡︡
︠e125ff60-8c67-4611-958b-46c3d38a4744s︠
f.parent()
︡c885201b-a3a1-439b-8b9b-ab2cd1f77e14︡{"stdout":"Callable function ring with arguments (z, william)\n"}
︠da01ee9a-458b-400b-8fe1-5e92b82f89aes︠
f - f
︡0ea6c944-8b29-4f2c-975a-80857be618a1︡{"stdout":"(z, 0\n"}︡{"done":true}︡{"done":true}︡
︠ea8ac024-7107-4d6b-a366-55b09e42e94ds︠
show(f)
︡a45484d2-38bc-45ad-9764-6e019a96977c︡{"html":"<div align='center'>$\\displaystyle \\left( z, \\mathit{william} \\right) \\ {\\mapsto} \\ \\mathit{william} {\\left(z + 1\\right)} z$</div>"}︡{"done":true}︡
︠ad6c059e-3b48-4a16-96c5-c8e95bb0038ess︠
# GOTCHA!
z = .5
f(z) = z*(z+1)  # this line whacks the previous defn of z!!
print f()
print z
︡8b85ec36-9c92-4b81-9ef0-427893465e88︡{"stdout":"(z + 1)*zb85ec36-9c92-4b81-9ef0-427893465e88︡{"stdout":"(z + 1)*z\n"}︡{"done":true}︡{"done":true}︡︡
︠af20cc27-792f-4433-853e-58156924022c︠

︡850a6570-cc4b-4222-845b-52383984cca6︡
︠453163f3-588f-40f3-967a-f1898cf4b47dss︠
typpe(z)
︡935251f5-4112-4def-a39c-42f5cbd1ebd6︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}
︠16a9787a-abc6-480e-a78b-21a8f1dc75b7︠
︡c7ff54ff-76bb-4e4c-b5ae-99a45093fac2︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}︡
︠146e6b36-80a2-436a-b7cb-9fba42c96b43s︠
z = .5
def f(z):
    print z
f(1)
print z
︡3779ccf8-0e8c-49f9-a78f-4d0fd8a86455︡{"stdout":"1\n"}︡{"stdout":"0.500000000000000\n"}
︠50ed26db-9a72-40b5-883b-4063d63c8df1ss︠

f(z) = z*(z+1)
g = plot(f, (0, 3), color='chartreuse', thickness=10ess=10, )  # has a bazillion options
show(g + text('hi there class!', (2,6), , zorder=))
︡90b8afa8-ad20-478f-9059-9fcac4c3f8ec︡︡︡︡
︠731fa8b6-9635-4d4b-8643-68193fe79321s︠

diff(x^5 + 2*x + pi, x)
diff(tan(x)^2, x)
︡d22d70ed-ae33-4e04-8b74-13053c2d2a1a︡{"stdout":"︡{"stdout":"2*(tan(x)^2 + 1)*tan(x)\n"}︡{"done":true}︡{"stdout":"cos(x)\n"}︡{"done":true}︡
︠ca29ea3d-e82d-4726-b4bb-4317d74b7568s︠
f = sin(x)*cos(x)*tan(x)
g = integrate(f, x)
show(g)
︡0a7b7610-99a7-401e-8eb5-dd8eb9f9d57e︡{"html":"<div align='center'>$\\displaystyle \\frac{1}{2} \\, x - \\frac{1}{4} \\, \\sin\\left(2 \\, x\\right)$</div>"}︡{"done":true}︡{"done":true}︡︡
︠fde52d90-a817-4f8b-8431-9c88fa4adeeds︠
h = g.differentiate(x)
show(h)
︡c83a2302-7641-4188-b652-251d89e2c6c0︡{"html":"<div align='center'>$\\displaystyle -\\frac{1}{2} \\, \\cos\\left(2 \\, x\\right) + \\frac{1}{2}$</div>"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/25149/tmp_5QQuPB.svg","show":true,"text":null,"uuid":"b8975826-6add-428f-a749-d8f08a53a4f0"},"once":false}︡
︠687c511a-3164-4a4d-9edd-3bcf69c4a935s︠
k = h - f
show(k)
︡047d7e46-1d2e-4a76-b848-dd2abeb03271︡{"html":"<div align='center'>$\\displaystyle -\\cos\\left(x\\right) \\sin\\left(x\\right) \\tan\\left(x\\right) - \\frac{1}{2} \\, \\cos\\left(2 \\, x\\right) + \\frac{1}{2}$</div>"}︡{"done":true}︡{"done":true}︡
︠b0d11e3d-ab62-47aa-b290-46fb8a869244s︠
k
︡7e3b1e0b-35fd-46c9-bad9-2f8e31031040︡{"stdout":"-cos(x)*sin(x)*tan(x) - 1/2*cos(2*x) + 1/2\n"}︡{"done":true}︡︡
︠b26bb415-d323-40ac-b867-d514de5427a7s︠
plot(k, 0, 1)
︡915f3996-2a1e-4dab-8410-d8213c497c5c︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/25149/tmp_RiXy9Gsvg","show":true,"text":null,"uuid":"2f6e9f43-71c3-4ea9-aa52-711a02e80d64"},"once":false}︡{"done":true}︡
︠0f857537-4ffb-4170-96dd-184683bc831fs︠
k.simplify_trig()
︡bf5c9aeb-a840-4adc-bdf2-ad9fae820692︡{"stdout":"0\n"}︡{"done":true}︡
︠228efa99-f7b6-47c7-9774-eb894d2acffes︠
k.simplify_full()
︡0f4cf9b1-2cab-46ba-93ac-325abeeef86e︡{"stdout":"0\n"}︡{"done":true}︡
︠3b7aa1dd-a5e5-46ab-ae78-e1fa74231ad6s︠
sin(x).find_root(-5,5)
︡b883f6a0-9775-4332-998f-2f73eb86b44b︡{"stdout":"0.0\n"}
︠5122e89e-7ac6-497d-9e77-b9422e317a0fs︠
N(sin(1/2), digits=50)
︡f96d4b09-054a-4717-b73d-bf36c792fe06︡{"stdout":"0.47942553860420300027328793521557138808180336794060\n"}︡{"done":true}{"done":true}︡{"done":true}︡︡
︠0d7371fa-3768-499d-a435-10eaf7ce3705s︠
complex_plot(x, (-1,1), (-1,1))
complex_plot(x^2^2, (-1,1), (-1,1))
︡77e422b9-83f3-4b38-8b28-3a87c2c618ee︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/25149/tmp_JpKWWpJpKWWp.svg","show":true,"text":null,"uuid":"c4f52ffe-1e85-49e3-89cc-5cb9826be348"},"once":false}︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/25149/tmp_UWiwn3.svg","show":true,"text":null,"uuid":"5290b9e7-1661-4962-893a-d3691c7c09d1"},"once":false}︡{"done":true}︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/25149/tmp_UWiwn3.svg","show":true,"text":null,"uuid":"5290b9e7-1661-4962-893a-d3691c7c09d1"},"once":false}︡{"done":true}︡
︠8c0ecc19-857c-4053-8584-e22819d35552s︠
f(x) = 1/sqrt(1-xx^4)
g = e(f,x)

diff(g,x)
︡7d7c7e4f-5c35-41b7-bc34-ce3f98af12b7︡{"stdout":"x |--> 1/sqrt(-x^4 + 1)\n"}︡{"done":true}︡︡
︠b32579de-5ae5-409b-813f-2f5587622e72s︠iplot(g))︡2bb7c7ed-96d9-4297-81c5-7d4a87207041︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/misc/decorators.py\", line 554, in wrapper\n    return func(*args, **options)\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/plot/plot.py\", line 1931, in plot\n    G = funcs.plot(*args, **original_opts)\n  File \"sage/symbolic/expression.pyx\", line 11386, in sage.symbolic.expression.Expression.plot (/projects/sage/sage-7.5/src/build/cythonized/sage/symbolic/expression.cpp:63509)\n    return plot(f, *args, **kwds)\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/misc/decorators.py\", line 554, in wrapper\n    return func(*args, **options)\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/plot/plot.py\", line 1946, in plot\n    G = _plot(funcs, (xmin, xmax), **kwds)\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/plot/plot.py\", line 2257, in _plot\n    randomize)\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/plot/plot.py\", line 3871, in generate_plot_points\n    data[i] = (float(xj), float(f(xj)))\n  File \"sage/ext/interpreters/wrapper_py.pyx\", line 68, in sage.ext.interpreters.wrapper_py.Wrapper_py.__call__ (/projects/sage/sage-7.5/src/build/cythonized/sage/ext/interpreters/wrapper_py.c:1800)\n    raise\n  File \"sage/ext/interpreters/wrapper_py.pyx\", line 60, in sage.ext.interpreters.wrapper_py.Wrapper_py.__call__ (/projects/sage/sage-7.5/src/build/cythonized/sage/ext/interpreters/wrapper_py.c:1734)\n    return interp_py((<PyTupleObject*>args).ob_item\n  File \"sage/symbolic/function.pyx\", line 996, in sage.symbolic.function.BuiltinFunction.__call__ (/projects/sage/sage-7.5/src/build/cythonized/sage/symbolic/function.cpp:11436)\n    res = super(BuiltinFunction, self).__call__(\n  File \"sage/symbolic/function.pyx\", line 491, in sage.symbolic.function.Function.__call__ (/projects/sage/sage-7.5/src/build/cythonized/sage/symbolic/function.cpp:6580)\n    res = g_function_eval2(self._serial, (<Expression>args[0])._gobj,\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/sage/symbolic/integration/integral.py\", line 78, in _eval_\n    if len(x.variables()) == 1:\nAttributeError: 'float' object has no attribute 'variables'\n"}︡{"done":true}︡{"done":true}︡
︠dd5717b5-c613-40cf-8477-3b88677ee731︠
(z)









